/* allegro_2.c
 * Ukazka programu v Allegru 2
 * Zobrazi rybu a pohybyje s ni po obrazovce
 *
 * Bernard Lidicky - 2004
 *
 * Je pod licenci GPL
 *
 * pro preklad mi fungovalo: "gcc allegro_2.c -o allegro_2 `allegro-config --cflags --libs`"
 */
 
#include <stdio.h>
#include <allegro.h>

// Funkce main
int main( )
{
	
	BITMAP *ryba;
	int x = 0, y = 0;
	
	// Inicializace Allegra
	if ( allegro_init() < 0 ) {
		fprintf(stderr, "Selhala inicializace Allegra.\n");
		exit(1);
	}

	// nastaveni barevne hloubky
	set_color_depth(16);
	
	// nastaveni grafickeho modu
//	if ( set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0) != 0 ){
	if ( set_gfx_mode(GFX_XWINDOWS, 640, 480, 0, 0) != 0 ){
			fprintf(stderr, "Nepodarilo nastavit rozliseni 640x480x16\n");
			exit(1);
	}
	
	// nacteme bitmaku
	ryba = load_bitmap( "ryba.bmp", NULL );
	if ( ryba == NULL ) {
		fprintf(stderr, "Nepodarilo se nacist soubor ryba.bmp.\n");
		exit(1);
	}

	while ( y < 480 ) {
		clear(screen);    //  smazani obrazovky
		draw_sprite(screen, ryba, x++, y++);  // nakresleni ryby
	}
	
	// uvolneni nactene bitmapky
	destroy_bitmap(ryba);
	
	// ukonceni Allegra - neni nutne volat
	allegro_exit();
	
	return 0;
}
// tohle musi byt za funkci main - zalezitost allegra
END_OF_MAIN();
