/* allegro_8.c
 * Ukazka programu v Allegru 
 * priklad pro  
 *
 * Bernard Lidicky - 2004
 *
 * Je pod licenci GPL
 *
 * pro preklad mi fungovalo: "gcc allegro_8.c -o allegro_8 `allegro-config --cflags --libs`"
 */
 
#include <stdio.h>
#include <allegro.h>

// nastaveni rozliseni 
// V normalni hre by se melo nacotat z konfiguracniho souboru
#define SCREEN_X   640
#define SCREEN_Y   480
#define SCREEN_BPP  16


// druha bitmapa velikosti obrazovky
BITMAP *back = NULL;


// veci pro hru

// obrazek Jake Jolieta (Blues Brothers)
BITMAP *jake;
BITMAP *ostrov;
BITMAP *ostrov_maska;

// souradnice Jake
int x = 0, y = 0;





/*
 * Provede inicializaci knihovny, nastavi rozliseni
 */
void InitSystem()
{
	

	// Inicializace Allegra
	if ( allegro_init() < 0 ) {
		fprintf(stderr, "Selhala inicializace Allegra.\n");
		exit(1);
	}

	// prirpavime klavesnici, mys a timer(cas)
	install_keyboard();
		   
	// nastaveni barevne hloubky
	set_color_depth(SCREEN_BPP);
	
	// nastaveni grafickeho modu
//	if ( set_gfx_mode(GFX_AUTODETECT, SCREEN_X, SCREEN_Y, 0, 0) != 0 ){
	if ( set_gfx_mode(GFX_XWINDOWS, SCREEN_X, SCREEN_Y, 0, 0) != 0 ){
			fprintf(stderr, "Nepodarilo nastavit rozliseni %dx%dx%d\n", SCREEN_X, SCREEN_Y, SCREEN_BPP);
			exit(1);
	}


	// vytvorime druhou obrazovku
	back = create_bitmap(SCREEN_X, SCREEN_Y);
	if ( back == NULL ) {
		fprintf(stderr, "Nepodarilo se vytvorit druhou bitmapu.\n");
		exit(1);
	}
}

/*
 * Provede na konci programu uklid
 */
void CleanAll()
{
	// uvolneni nactenych bitmapek
	destroy_bitmap(jake);
	destroy_bitmap(ostrov);
	destroy_bitmap(ostrov_maska);

	// uvolneni bitmapy s druhou obrazovkou
	destroy_bitmap(back);
	
	// ukonceni Allegra - neni nutne volat
	allegro_exit();
}

/*
 * Nacte bitmapy a podobne veci
 */
void InitGame()
{
	// nacteme bitmaku
	jake = load_bitmap( "jake.bmp", NULL );
	if ( jake == NULL ) {
		fprintf(stderr, "Nepodarilo se nacist soubor jake.bmp.\n");
		exit(1);
	}

	ostrov = load_bitmap( "ostrov.bmp", NULL );
	if ( ostrov == NULL ) {
		fprintf(stderr, "Nepodarilo se nacist soubor ostrov.bmp.\n");
		exit(1);
	}
	
	ostrov_maska = load_bitmap( "maska.bmp", NULL );
	if ( jake == NULL ) {
		fprintf(stderr, "Nepodarilo se nacist soubor maska.bmp.\n");
		exit(1);
	}

	// nastavime sourabnice Jaka
	x = 200;
	y = 200;
}

/*
 * Funkce pro pohnuti svetem hry - tedy rybou a zpracovani vstupu uzivatele
 */
void MoveGameWorld()
{
	// pro vypocet novych souradnic
	int new_x = x, new_y = y;
	
	// aktualizace klavesnice
	poll_keyboard();
	
	// posun
	if ( key[KEY_UP] ) new_y--;
	if ( key[KEY_DOWN] ) new_y++;
	if ( key[KEY_LEFT] ) new_x--;
	if ( key[KEY_RIGHT] ) new_x++;
		

	// test, zda v masce ostrova je na souradnici new_xy neni cerva 
	//- pak by tam neslo jit.
	if ( getpixel(ostrov_maska, new_x, new_y) != 0 ) {
		x = new_x;
		y = new_y;
	}

	
	// omezeni Jaka
	if ( x < 0 ) x += SCREEN_X;
	if ( y < 0 ) y += SCREEN_Y;
	if ( y > SCREEN_Y ) y -= SCREEN_Y;
	if ( x > SCREEN_X ) x -= SCREEN_X;

}

/*
 * Funkce pro nakresleni sveta hry
 */
void DrawGameWorld()
{
	//  nakresleni pozadi
	draw_sprite(back, ostrov, 0, 0);

	// nakreslime jaka - posuneme ho, aby x,y urcovalo spodek jeho bot
	draw_sprite(back, jake, x-jake->w/2, y-jake->h+2); 

	// aktualizace obrazovku
	draw_sprite(screen, back, 0, 0);
}

// Funkce main
int main( )
{
	// inicializace Allegra
	InitSystem();

	// nacteni bitmapek a podobne
	InitGame();
	
	
	while ( !key[KEY_Q] ) { // hrajeme, koduk se nezmackne q
		
		MoveGameWorld();

		DrawGameWorld();
		
	}

	CleanAll();	

return 0;
}
// tohle musi byt za funkci main - zalezitost allegra
END_OF_MAIN();

